/**
 * THIS FILE IS AUTOMATICALLY GENERATED. ANY MODIFICATIONS TO IT WILL BE OVERWRITTEN
 */

#include "./array.h"
#include "../mem_allocator/mem_allocator.h"
#include "../../common/misc/misc_utils.h"
#include "../../common/aliases/aliases.h"
#include "../../common/platform/platform.h"
#include <stddef.h>
#include <stdbool.h>

Str8 *wapp_str8_array_get(const Str8Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (Str8 *)ptr;
}

void wapp_str8_array_set(Str8Array *array, u64 index, Str8 *item) {
  Str8 *ptr = wapp_str8_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_str8_array_append_capped(Str8Array *array, Str8 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_str8_array_set(array, index, item);
}

void wapp_str8_array_extend_capped(Str8Array *array, const Str8Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  Str8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_str8_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_str8_array_append_capped(array, item);
  }
}

void wapp_str8_array_clear(Str8Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_str8_array_copy_capped(const Str8Array *src, Str8Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_str8_array_clear(dst);

  Str8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_str8_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_str8_array_append_capped(dst, item);
  }
}

Str8Array *wapp_str8_array_append_alloc(const Allocator *allocator, Str8Array *array, Str8 *item) {
  Str8Array *output = array;

  if (!allocator || !array) {
    goto RETURN_STR8_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (Str8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_STR8_ARRAY_APPEND_ALLOC;
    }
    wapp_str8_array_copy_capped(array, output);
  }

  wapp_str8_array_append_capped(output, item);

RETURN_STR8_ARRAY_APPEND_ALLOC:
  return output;
}

Str8Array *wapp_str8_array_extend_alloc(const Allocator *allocator, Str8Array *array, const Str8Array *other) {
  Str8Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_STR8_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (Str8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_STR8_ARRAY_EXTEND_ALLOC;
    }
    wapp_str8_array_copy_capped(array, output);
  }

  wapp_str8_array_extend_capped(output, other);

RETURN_STR8_ARRAY_EXTEND_ALLOC:
  return output;
}

Str8Array *wapp_str8_array_copy_alloc(const Allocator *allocator, const Str8Array *src, Str8Array *dst) {
  Str8Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_STR8_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (Str8Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_STR8_ARRAY_COPY_ALLOC;
    }
  }

  wapp_str8_array_clear(output);
  wapp_str8_array_copy_capped(src, output);

RETURN_STR8_ARRAY_COPY_ALLOC:
  return output;
}

Str8 *_str8_array_pop(Str8Array *array) {
  u64 index = array->count - 1;
  Str8 *out = wapp_str8_array_get(array, index);
  --(array->count);
  return out;
}

void * *wapp_void_ptr_array_get(const VoidPArray *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (void * *)ptr;
}

void wapp_void_ptr_array_set(VoidPArray *array, u64 index, void * *item) {
  void * *ptr = wapp_void_ptr_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_void_ptr_array_append_capped(VoidPArray *array, void * *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_void_ptr_array_set(array, index, item);
}

void wapp_void_ptr_array_extend_capped(VoidPArray *array, const VoidPArray *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  void * *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_void_ptr_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_void_ptr_array_append_capped(array, item);
  }
}

void wapp_void_ptr_array_clear(VoidPArray *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_void_ptr_array_copy_capped(const VoidPArray *src, VoidPArray *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_void_ptr_array_clear(dst);

  void * *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_void_ptr_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_void_ptr_array_append_capped(dst, item);
  }
}

VoidPArray *wapp_void_ptr_array_append_alloc(const Allocator *allocator, VoidPArray *array, void * *item) {
  VoidPArray *output = array;

  if (!allocator || !array) {
    goto RETURN_VOID_PTR_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (VoidPArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_VOID_PTR_ARRAY_APPEND_ALLOC;
    }
    wapp_void_ptr_array_copy_capped(array, output);
  }

  wapp_void_ptr_array_append_capped(output, item);

RETURN_VOID_PTR_ARRAY_APPEND_ALLOC:
  return output;
}

VoidPArray *wapp_void_ptr_array_extend_alloc(const Allocator *allocator, VoidPArray *array, const VoidPArray *other) {
  VoidPArray *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_VOID_PTR_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (VoidPArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_VOID_PTR_ARRAY_EXTEND_ALLOC;
    }
    wapp_void_ptr_array_copy_capped(array, output);
  }

  wapp_void_ptr_array_extend_capped(output, other);

RETURN_VOID_PTR_ARRAY_EXTEND_ALLOC:
  return output;
}

VoidPArray *wapp_void_ptr_array_copy_alloc(const Allocator *allocator, const VoidPArray *src, VoidPArray *dst) {
  VoidPArray *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_VOID_PTR_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (VoidPArray *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_VOID_PTR_ARRAY_COPY_ALLOC;
    }
  }

  wapp_void_ptr_array_clear(output);
  wapp_void_ptr_array_copy_capped(src, output);

RETURN_VOID_PTR_ARRAY_COPY_ALLOC:
  return output;
}

void * *_void_ptr_array_pop(VoidPArray *array) {
  u64 index = array->count - 1;
  void * *out = wapp_void_ptr_array_get(array, index);
  --(array->count);
  return out;
}

bool *wapp_bool_array_get(const BoolArray *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (bool *)ptr;
}

void wapp_bool_array_set(BoolArray *array, u64 index, bool *item) {
  bool *ptr = wapp_bool_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_bool_array_append_capped(BoolArray *array, bool *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_bool_array_set(array, index, item);
}

void wapp_bool_array_extend_capped(BoolArray *array, const BoolArray *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  bool *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_bool_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_bool_array_append_capped(array, item);
  }
}

void wapp_bool_array_clear(BoolArray *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_bool_array_copy_capped(const BoolArray *src, BoolArray *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_bool_array_clear(dst);

  bool *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_bool_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_bool_array_append_capped(dst, item);
  }
}

BoolArray *wapp_bool_array_append_alloc(const Allocator *allocator, BoolArray *array, bool *item) {
  BoolArray *output = array;

  if (!allocator || !array) {
    goto RETURN_BOOL_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (BoolArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_BOOL_ARRAY_APPEND_ALLOC;
    }
    wapp_bool_array_copy_capped(array, output);
  }

  wapp_bool_array_append_capped(output, item);

RETURN_BOOL_ARRAY_APPEND_ALLOC:
  return output;
}

BoolArray *wapp_bool_array_extend_alloc(const Allocator *allocator, BoolArray *array, const BoolArray *other) {
  BoolArray *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_BOOL_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (BoolArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_BOOL_ARRAY_EXTEND_ALLOC;
    }
    wapp_bool_array_copy_capped(array, output);
  }

  wapp_bool_array_extend_capped(output, other);

RETURN_BOOL_ARRAY_EXTEND_ALLOC:
  return output;
}

BoolArray *wapp_bool_array_copy_alloc(const Allocator *allocator, const BoolArray *src, BoolArray *dst) {
  BoolArray *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_BOOL_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (BoolArray *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_BOOL_ARRAY_COPY_ALLOC;
    }
  }

  wapp_bool_array_clear(output);
  wapp_bool_array_copy_capped(src, output);

RETURN_BOOL_ARRAY_COPY_ALLOC:
  return output;
}

bool *_bool_array_pop(BoolArray *array) {
  u64 index = array->count - 1;
  bool *out = wapp_bool_array_get(array, index);
  --(array->count);
  return out;
}

char *wapp_char_array_get(const CharArray *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (char *)ptr;
}

void wapp_char_array_set(CharArray *array, u64 index, char *item) {
  char *ptr = wapp_char_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_char_array_append_capped(CharArray *array, char *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_char_array_set(array, index, item);
}

void wapp_char_array_extend_capped(CharArray *array, const CharArray *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  char *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_char_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_char_array_append_capped(array, item);
  }
}

void wapp_char_array_clear(CharArray *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_char_array_copy_capped(const CharArray *src, CharArray *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_char_array_clear(dst);

  char *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_char_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_char_array_append_capped(dst, item);
  }
}

CharArray *wapp_char_array_append_alloc(const Allocator *allocator, CharArray *array, char *item) {
  CharArray *output = array;

  if (!allocator || !array) {
    goto RETURN_CHAR_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (CharArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_CHAR_ARRAY_APPEND_ALLOC;
    }
    wapp_char_array_copy_capped(array, output);
  }

  wapp_char_array_append_capped(output, item);

RETURN_CHAR_ARRAY_APPEND_ALLOC:
  return output;
}

CharArray *wapp_char_array_extend_alloc(const Allocator *allocator, CharArray *array, const CharArray *other) {
  CharArray *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_CHAR_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (CharArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_CHAR_ARRAY_EXTEND_ALLOC;
    }
    wapp_char_array_copy_capped(array, output);
  }

  wapp_char_array_extend_capped(output, other);

RETURN_CHAR_ARRAY_EXTEND_ALLOC:
  return output;
}

CharArray *wapp_char_array_copy_alloc(const Allocator *allocator, const CharArray *src, CharArray *dst) {
  CharArray *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_CHAR_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (CharArray *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_CHAR_ARRAY_COPY_ALLOC;
    }
  }

  wapp_char_array_clear(output);
  wapp_char_array_copy_capped(src, output);

RETURN_CHAR_ARRAY_COPY_ALLOC:
  return output;
}

char *_char_array_pop(CharArray *array) {
  u64 index = array->count - 1;
  char *out = wapp_char_array_get(array, index);
  --(array->count);
  return out;
}

c8 *wapp_c8_array_get(const C8Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (c8 *)ptr;
}

void wapp_c8_array_set(C8Array *array, u64 index, c8 *item) {
  c8 *ptr = wapp_c8_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_c8_array_append_capped(C8Array *array, c8 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_c8_array_set(array, index, item);
}

void wapp_c8_array_extend_capped(C8Array *array, const C8Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  c8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_c8_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_c8_array_append_capped(array, item);
  }
}

void wapp_c8_array_clear(C8Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_c8_array_copy_capped(const C8Array *src, C8Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_c8_array_clear(dst);

  c8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_c8_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_c8_array_append_capped(dst, item);
  }
}

C8Array *wapp_c8_array_append_alloc(const Allocator *allocator, C8Array *array, c8 *item) {
  C8Array *output = array;

  if (!allocator || !array) {
    goto RETURN_C8_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (C8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_C8_ARRAY_APPEND_ALLOC;
    }
    wapp_c8_array_copy_capped(array, output);
  }

  wapp_c8_array_append_capped(output, item);

RETURN_C8_ARRAY_APPEND_ALLOC:
  return output;
}

C8Array *wapp_c8_array_extend_alloc(const Allocator *allocator, C8Array *array, const C8Array *other) {
  C8Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_C8_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (C8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_C8_ARRAY_EXTEND_ALLOC;
    }
    wapp_c8_array_copy_capped(array, output);
  }

  wapp_c8_array_extend_capped(output, other);

RETURN_C8_ARRAY_EXTEND_ALLOC:
  return output;
}

C8Array *wapp_c8_array_copy_alloc(const Allocator *allocator, const C8Array *src, C8Array *dst) {
  C8Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_C8_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (C8Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_C8_ARRAY_COPY_ALLOC;
    }
  }

  wapp_c8_array_clear(output);
  wapp_c8_array_copy_capped(src, output);

RETURN_C8_ARRAY_COPY_ALLOC:
  return output;
}

c8 *_c8_array_pop(C8Array *array) {
  u64 index = array->count - 1;
  c8 *out = wapp_c8_array_get(array, index);
  --(array->count);
  return out;
}

c16 *wapp_c16_array_get(const C16Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (c16 *)ptr;
}

void wapp_c16_array_set(C16Array *array, u64 index, c16 *item) {
  c16 *ptr = wapp_c16_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_c16_array_append_capped(C16Array *array, c16 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_c16_array_set(array, index, item);
}

void wapp_c16_array_extend_capped(C16Array *array, const C16Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  c16 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_c16_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_c16_array_append_capped(array, item);
  }
}

void wapp_c16_array_clear(C16Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_c16_array_copy_capped(const C16Array *src, C16Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_c16_array_clear(dst);

  c16 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_c16_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_c16_array_append_capped(dst, item);
  }
}

C16Array *wapp_c16_array_append_alloc(const Allocator *allocator, C16Array *array, c16 *item) {
  C16Array *output = array;

  if (!allocator || !array) {
    goto RETURN_C16_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (C16Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_C16_ARRAY_APPEND_ALLOC;
    }
    wapp_c16_array_copy_capped(array, output);
  }

  wapp_c16_array_append_capped(output, item);

RETURN_C16_ARRAY_APPEND_ALLOC:
  return output;
}

C16Array *wapp_c16_array_extend_alloc(const Allocator *allocator, C16Array *array, const C16Array *other) {
  C16Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_C16_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (C16Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_C16_ARRAY_EXTEND_ALLOC;
    }
    wapp_c16_array_copy_capped(array, output);
  }

  wapp_c16_array_extend_capped(output, other);

RETURN_C16_ARRAY_EXTEND_ALLOC:
  return output;
}

C16Array *wapp_c16_array_copy_alloc(const Allocator *allocator, const C16Array *src, C16Array *dst) {
  C16Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_C16_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (C16Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_C16_ARRAY_COPY_ALLOC;
    }
  }

  wapp_c16_array_clear(output);
  wapp_c16_array_copy_capped(src, output);

RETURN_C16_ARRAY_COPY_ALLOC:
  return output;
}

c16 *_c16_array_pop(C16Array *array) {
  u64 index = array->count - 1;
  c16 *out = wapp_c16_array_get(array, index);
  --(array->count);
  return out;
}

c32 *wapp_c32_array_get(const C32Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (c32 *)ptr;
}

void wapp_c32_array_set(C32Array *array, u64 index, c32 *item) {
  c32 *ptr = wapp_c32_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_c32_array_append_capped(C32Array *array, c32 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_c32_array_set(array, index, item);
}

void wapp_c32_array_extend_capped(C32Array *array, const C32Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  c32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_c32_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_c32_array_append_capped(array, item);
  }
}

void wapp_c32_array_clear(C32Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_c32_array_copy_capped(const C32Array *src, C32Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_c32_array_clear(dst);

  c32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_c32_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_c32_array_append_capped(dst, item);
  }
}

C32Array *wapp_c32_array_append_alloc(const Allocator *allocator, C32Array *array, c32 *item) {
  C32Array *output = array;

  if (!allocator || !array) {
    goto RETURN_C32_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (C32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_C32_ARRAY_APPEND_ALLOC;
    }
    wapp_c32_array_copy_capped(array, output);
  }

  wapp_c32_array_append_capped(output, item);

RETURN_C32_ARRAY_APPEND_ALLOC:
  return output;
}

C32Array *wapp_c32_array_extend_alloc(const Allocator *allocator, C32Array *array, const C32Array *other) {
  C32Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_C32_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (C32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_C32_ARRAY_EXTEND_ALLOC;
    }
    wapp_c32_array_copy_capped(array, output);
  }

  wapp_c32_array_extend_capped(output, other);

RETURN_C32_ARRAY_EXTEND_ALLOC:
  return output;
}

C32Array *wapp_c32_array_copy_alloc(const Allocator *allocator, const C32Array *src, C32Array *dst) {
  C32Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_C32_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (C32Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_C32_ARRAY_COPY_ALLOC;
    }
  }

  wapp_c32_array_clear(output);
  wapp_c32_array_copy_capped(src, output);

RETURN_C32_ARRAY_COPY_ALLOC:
  return output;
}

c32 *_c32_array_pop(C32Array *array) {
  u64 index = array->count - 1;
  c32 *out = wapp_c32_array_get(array, index);
  --(array->count);
  return out;
}

i8 *wapp_i8_array_get(const I8Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (i8 *)ptr;
}

void wapp_i8_array_set(I8Array *array, u64 index, i8 *item) {
  i8 *ptr = wapp_i8_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_i8_array_append_capped(I8Array *array, i8 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_i8_array_set(array, index, item);
}

void wapp_i8_array_extend_capped(I8Array *array, const I8Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  i8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_i8_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_i8_array_append_capped(array, item);
  }
}

void wapp_i8_array_clear(I8Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_i8_array_copy_capped(const I8Array *src, I8Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_i8_array_clear(dst);

  i8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_i8_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_i8_array_append_capped(dst, item);
  }
}

I8Array *wapp_i8_array_append_alloc(const Allocator *allocator, I8Array *array, i8 *item) {
  I8Array *output = array;

  if (!allocator || !array) {
    goto RETURN_I8_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I8_ARRAY_APPEND_ALLOC;
    }
    wapp_i8_array_copy_capped(array, output);
  }

  wapp_i8_array_append_capped(output, item);

RETURN_I8_ARRAY_APPEND_ALLOC:
  return output;
}

I8Array *wapp_i8_array_extend_alloc(const Allocator *allocator, I8Array *array, const I8Array *other) {
  I8Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_I8_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I8_ARRAY_EXTEND_ALLOC;
    }
    wapp_i8_array_copy_capped(array, output);
  }

  wapp_i8_array_extend_capped(output, other);

RETURN_I8_ARRAY_EXTEND_ALLOC:
  return output;
}

I8Array *wapp_i8_array_copy_alloc(const Allocator *allocator, const I8Array *src, I8Array *dst) {
  I8Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_I8_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (I8Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_I8_ARRAY_COPY_ALLOC;
    }
  }

  wapp_i8_array_clear(output);
  wapp_i8_array_copy_capped(src, output);

RETURN_I8_ARRAY_COPY_ALLOC:
  return output;
}

i8 *_i8_array_pop(I8Array *array) {
  u64 index = array->count - 1;
  i8 *out = wapp_i8_array_get(array, index);
  --(array->count);
  return out;
}

i16 *wapp_i16_array_get(const I16Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (i16 *)ptr;
}

void wapp_i16_array_set(I16Array *array, u64 index, i16 *item) {
  i16 *ptr = wapp_i16_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_i16_array_append_capped(I16Array *array, i16 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_i16_array_set(array, index, item);
}

void wapp_i16_array_extend_capped(I16Array *array, const I16Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  i16 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_i16_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_i16_array_append_capped(array, item);
  }
}

void wapp_i16_array_clear(I16Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_i16_array_copy_capped(const I16Array *src, I16Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_i16_array_clear(dst);

  i16 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_i16_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_i16_array_append_capped(dst, item);
  }
}

I16Array *wapp_i16_array_append_alloc(const Allocator *allocator, I16Array *array, i16 *item) {
  I16Array *output = array;

  if (!allocator || !array) {
    goto RETURN_I16_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I16Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I16_ARRAY_APPEND_ALLOC;
    }
    wapp_i16_array_copy_capped(array, output);
  }

  wapp_i16_array_append_capped(output, item);

RETURN_I16_ARRAY_APPEND_ALLOC:
  return output;
}

I16Array *wapp_i16_array_extend_alloc(const Allocator *allocator, I16Array *array, const I16Array *other) {
  I16Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_I16_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I16Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I16_ARRAY_EXTEND_ALLOC;
    }
    wapp_i16_array_copy_capped(array, output);
  }

  wapp_i16_array_extend_capped(output, other);

RETURN_I16_ARRAY_EXTEND_ALLOC:
  return output;
}

I16Array *wapp_i16_array_copy_alloc(const Allocator *allocator, const I16Array *src, I16Array *dst) {
  I16Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_I16_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (I16Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_I16_ARRAY_COPY_ALLOC;
    }
  }

  wapp_i16_array_clear(output);
  wapp_i16_array_copy_capped(src, output);

RETURN_I16_ARRAY_COPY_ALLOC:
  return output;
}

i16 *_i16_array_pop(I16Array *array) {
  u64 index = array->count - 1;
  i16 *out = wapp_i16_array_get(array, index);
  --(array->count);
  return out;
}

i32 *wapp_i32_array_get(const I32Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (i32 *)ptr;
}

void wapp_i32_array_set(I32Array *array, u64 index, i32 *item) {
  i32 *ptr = wapp_i32_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_i32_array_append_capped(I32Array *array, i32 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_i32_array_set(array, index, item);
}

void wapp_i32_array_extend_capped(I32Array *array, const I32Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  i32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_i32_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_i32_array_append_capped(array, item);
  }
}

void wapp_i32_array_clear(I32Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_i32_array_copy_capped(const I32Array *src, I32Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_i32_array_clear(dst);

  i32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_i32_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_i32_array_append_capped(dst, item);
  }
}

I32Array *wapp_i32_array_append_alloc(const Allocator *allocator, I32Array *array, i32 *item) {
  I32Array *output = array;

  if (!allocator || !array) {
    goto RETURN_I32_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I32_ARRAY_APPEND_ALLOC;
    }
    wapp_i32_array_copy_capped(array, output);
  }

  wapp_i32_array_append_capped(output, item);

RETURN_I32_ARRAY_APPEND_ALLOC:
  return output;
}

I32Array *wapp_i32_array_extend_alloc(const Allocator *allocator, I32Array *array, const I32Array *other) {
  I32Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_I32_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I32_ARRAY_EXTEND_ALLOC;
    }
    wapp_i32_array_copy_capped(array, output);
  }

  wapp_i32_array_extend_capped(output, other);

RETURN_I32_ARRAY_EXTEND_ALLOC:
  return output;
}

I32Array *wapp_i32_array_copy_alloc(const Allocator *allocator, const I32Array *src, I32Array *dst) {
  I32Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_I32_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (I32Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_I32_ARRAY_COPY_ALLOC;
    }
  }

  wapp_i32_array_clear(output);
  wapp_i32_array_copy_capped(src, output);

RETURN_I32_ARRAY_COPY_ALLOC:
  return output;
}

i32 *_i32_array_pop(I32Array *array) {
  u64 index = array->count - 1;
  i32 *out = wapp_i32_array_get(array, index);
  --(array->count);
  return out;
}

i64 *wapp_i64_array_get(const I64Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (i64 *)ptr;
}

void wapp_i64_array_set(I64Array *array, u64 index, i64 *item) {
  i64 *ptr = wapp_i64_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_i64_array_append_capped(I64Array *array, i64 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_i64_array_set(array, index, item);
}

void wapp_i64_array_extend_capped(I64Array *array, const I64Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  i64 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_i64_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_i64_array_append_capped(array, item);
  }
}

void wapp_i64_array_clear(I64Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_i64_array_copy_capped(const I64Array *src, I64Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_i64_array_clear(dst);

  i64 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_i64_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_i64_array_append_capped(dst, item);
  }
}

I64Array *wapp_i64_array_append_alloc(const Allocator *allocator, I64Array *array, i64 *item) {
  I64Array *output = array;

  if (!allocator || !array) {
    goto RETURN_I64_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I64Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I64_ARRAY_APPEND_ALLOC;
    }
    wapp_i64_array_copy_capped(array, output);
  }

  wapp_i64_array_append_capped(output, item);

RETURN_I64_ARRAY_APPEND_ALLOC:
  return output;
}

I64Array *wapp_i64_array_extend_alloc(const Allocator *allocator, I64Array *array, const I64Array *other) {
  I64Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_I64_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (I64Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_I64_ARRAY_EXTEND_ALLOC;
    }
    wapp_i64_array_copy_capped(array, output);
  }

  wapp_i64_array_extend_capped(output, other);

RETURN_I64_ARRAY_EXTEND_ALLOC:
  return output;
}

I64Array *wapp_i64_array_copy_alloc(const Allocator *allocator, const I64Array *src, I64Array *dst) {
  I64Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_I64_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (I64Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_I64_ARRAY_COPY_ALLOC;
    }
  }

  wapp_i64_array_clear(output);
  wapp_i64_array_copy_capped(src, output);

RETURN_I64_ARRAY_COPY_ALLOC:
  return output;
}

i64 *_i64_array_pop(I64Array *array) {
  u64 index = array->count - 1;
  i64 *out = wapp_i64_array_get(array, index);
  --(array->count);
  return out;
}

u8 *wapp_u8_array_get(const U8Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (u8 *)ptr;
}

void wapp_u8_array_set(U8Array *array, u64 index, u8 *item) {
  u8 *ptr = wapp_u8_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_u8_array_append_capped(U8Array *array, u8 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_u8_array_set(array, index, item);
}

void wapp_u8_array_extend_capped(U8Array *array, const U8Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  u8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_u8_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_u8_array_append_capped(array, item);
  }
}

void wapp_u8_array_clear(U8Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_u8_array_copy_capped(const U8Array *src, U8Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_u8_array_clear(dst);

  u8 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_u8_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_u8_array_append_capped(dst, item);
  }
}

U8Array *wapp_u8_array_append_alloc(const Allocator *allocator, U8Array *array, u8 *item) {
  U8Array *output = array;

  if (!allocator || !array) {
    goto RETURN_U8_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U8_ARRAY_APPEND_ALLOC;
    }
    wapp_u8_array_copy_capped(array, output);
  }

  wapp_u8_array_append_capped(output, item);

RETURN_U8_ARRAY_APPEND_ALLOC:
  return output;
}

U8Array *wapp_u8_array_extend_alloc(const Allocator *allocator, U8Array *array, const U8Array *other) {
  U8Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_U8_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U8Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U8_ARRAY_EXTEND_ALLOC;
    }
    wapp_u8_array_copy_capped(array, output);
  }

  wapp_u8_array_extend_capped(output, other);

RETURN_U8_ARRAY_EXTEND_ALLOC:
  return output;
}

U8Array *wapp_u8_array_copy_alloc(const Allocator *allocator, const U8Array *src, U8Array *dst) {
  U8Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_U8_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (U8Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_U8_ARRAY_COPY_ALLOC;
    }
  }

  wapp_u8_array_clear(output);
  wapp_u8_array_copy_capped(src, output);

RETURN_U8_ARRAY_COPY_ALLOC:
  return output;
}

u8 *_u8_array_pop(U8Array *array) {
  u64 index = array->count - 1;
  u8 *out = wapp_u8_array_get(array, index);
  --(array->count);
  return out;
}

u16 *wapp_u16_array_get(const U16Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (u16 *)ptr;
}

void wapp_u16_array_set(U16Array *array, u64 index, u16 *item) {
  u16 *ptr = wapp_u16_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_u16_array_append_capped(U16Array *array, u16 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_u16_array_set(array, index, item);
}

void wapp_u16_array_extend_capped(U16Array *array, const U16Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  u16 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_u16_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_u16_array_append_capped(array, item);
  }
}

void wapp_u16_array_clear(U16Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_u16_array_copy_capped(const U16Array *src, U16Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_u16_array_clear(dst);

  u16 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_u16_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_u16_array_append_capped(dst, item);
  }
}

U16Array *wapp_u16_array_append_alloc(const Allocator *allocator, U16Array *array, u16 *item) {
  U16Array *output = array;

  if (!allocator || !array) {
    goto RETURN_U16_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U16Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U16_ARRAY_APPEND_ALLOC;
    }
    wapp_u16_array_copy_capped(array, output);
  }

  wapp_u16_array_append_capped(output, item);

RETURN_U16_ARRAY_APPEND_ALLOC:
  return output;
}

U16Array *wapp_u16_array_extend_alloc(const Allocator *allocator, U16Array *array, const U16Array *other) {
  U16Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_U16_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U16Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U16_ARRAY_EXTEND_ALLOC;
    }
    wapp_u16_array_copy_capped(array, output);
  }

  wapp_u16_array_extend_capped(output, other);

RETURN_U16_ARRAY_EXTEND_ALLOC:
  return output;
}

U16Array *wapp_u16_array_copy_alloc(const Allocator *allocator, const U16Array *src, U16Array *dst) {
  U16Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_U16_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (U16Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_U16_ARRAY_COPY_ALLOC;
    }
  }

  wapp_u16_array_clear(output);
  wapp_u16_array_copy_capped(src, output);

RETURN_U16_ARRAY_COPY_ALLOC:
  return output;
}

u16 *_u16_array_pop(U16Array *array) {
  u64 index = array->count - 1;
  u16 *out = wapp_u16_array_get(array, index);
  --(array->count);
  return out;
}

u32 *wapp_u32_array_get(const U32Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (u32 *)ptr;
}

void wapp_u32_array_set(U32Array *array, u64 index, u32 *item) {
  u32 *ptr = wapp_u32_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_u32_array_append_capped(U32Array *array, u32 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_u32_array_set(array, index, item);
}

void wapp_u32_array_extend_capped(U32Array *array, const U32Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  u32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_u32_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_u32_array_append_capped(array, item);
  }
}

void wapp_u32_array_clear(U32Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_u32_array_copy_capped(const U32Array *src, U32Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_u32_array_clear(dst);

  u32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_u32_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_u32_array_append_capped(dst, item);
  }
}

U32Array *wapp_u32_array_append_alloc(const Allocator *allocator, U32Array *array, u32 *item) {
  U32Array *output = array;

  if (!allocator || !array) {
    goto RETURN_U32_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U32_ARRAY_APPEND_ALLOC;
    }
    wapp_u32_array_copy_capped(array, output);
  }

  wapp_u32_array_append_capped(output, item);

RETURN_U32_ARRAY_APPEND_ALLOC:
  return output;
}

U32Array *wapp_u32_array_extend_alloc(const Allocator *allocator, U32Array *array, const U32Array *other) {
  U32Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_U32_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U32_ARRAY_EXTEND_ALLOC;
    }
    wapp_u32_array_copy_capped(array, output);
  }

  wapp_u32_array_extend_capped(output, other);

RETURN_U32_ARRAY_EXTEND_ALLOC:
  return output;
}

U32Array *wapp_u32_array_copy_alloc(const Allocator *allocator, const U32Array *src, U32Array *dst) {
  U32Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_U32_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (U32Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_U32_ARRAY_COPY_ALLOC;
    }
  }

  wapp_u32_array_clear(output);
  wapp_u32_array_copy_capped(src, output);

RETURN_U32_ARRAY_COPY_ALLOC:
  return output;
}

u32 *_u32_array_pop(U32Array *array) {
  u64 index = array->count - 1;
  u32 *out = wapp_u32_array_get(array, index);
  --(array->count);
  return out;
}

u64 *wapp_u64_array_get(const U64Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (u64 *)ptr;
}

void wapp_u64_array_set(U64Array *array, u64 index, u64 *item) {
  u64 *ptr = wapp_u64_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_u64_array_append_capped(U64Array *array, u64 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_u64_array_set(array, index, item);
}

void wapp_u64_array_extend_capped(U64Array *array, const U64Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  u64 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_u64_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_u64_array_append_capped(array, item);
  }
}

void wapp_u64_array_clear(U64Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_u64_array_copy_capped(const U64Array *src, U64Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_u64_array_clear(dst);

  u64 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_u64_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_u64_array_append_capped(dst, item);
  }
}

U64Array *wapp_u64_array_append_alloc(const Allocator *allocator, U64Array *array, u64 *item) {
  U64Array *output = array;

  if (!allocator || !array) {
    goto RETURN_U64_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U64Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U64_ARRAY_APPEND_ALLOC;
    }
    wapp_u64_array_copy_capped(array, output);
  }

  wapp_u64_array_append_capped(output, item);

RETURN_U64_ARRAY_APPEND_ALLOC:
  return output;
}

U64Array *wapp_u64_array_extend_alloc(const Allocator *allocator, U64Array *array, const U64Array *other) {
  U64Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_U64_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (U64Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_U64_ARRAY_EXTEND_ALLOC;
    }
    wapp_u64_array_copy_capped(array, output);
  }

  wapp_u64_array_extend_capped(output, other);

RETURN_U64_ARRAY_EXTEND_ALLOC:
  return output;
}

U64Array *wapp_u64_array_copy_alloc(const Allocator *allocator, const U64Array *src, U64Array *dst) {
  U64Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_U64_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (U64Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_U64_ARRAY_COPY_ALLOC;
    }
  }

  wapp_u64_array_clear(output);
  wapp_u64_array_copy_capped(src, output);

RETURN_U64_ARRAY_COPY_ALLOC:
  return output;
}

u64 *_u64_array_pop(U64Array *array) {
  u64 index = array->count - 1;
  u64 *out = wapp_u64_array_get(array, index);
  --(array->count);
  return out;
}

f32 *wapp_f32_array_get(const F32Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (f32 *)ptr;
}

void wapp_f32_array_set(F32Array *array, u64 index, f32 *item) {
  f32 *ptr = wapp_f32_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_f32_array_append_capped(F32Array *array, f32 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_f32_array_set(array, index, item);
}

void wapp_f32_array_extend_capped(F32Array *array, const F32Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  f32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_f32_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_f32_array_append_capped(array, item);
  }
}

void wapp_f32_array_clear(F32Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_f32_array_copy_capped(const F32Array *src, F32Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_f32_array_clear(dst);

  f32 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_f32_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_f32_array_append_capped(dst, item);
  }
}

F32Array *wapp_f32_array_append_alloc(const Allocator *allocator, F32Array *array, f32 *item) {
  F32Array *output = array;

  if (!allocator || !array) {
    goto RETURN_F32_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (F32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_F32_ARRAY_APPEND_ALLOC;
    }
    wapp_f32_array_copy_capped(array, output);
  }

  wapp_f32_array_append_capped(output, item);

RETURN_F32_ARRAY_APPEND_ALLOC:
  return output;
}

F32Array *wapp_f32_array_extend_alloc(const Allocator *allocator, F32Array *array, const F32Array *other) {
  F32Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_F32_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (F32Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_F32_ARRAY_EXTEND_ALLOC;
    }
    wapp_f32_array_copy_capped(array, output);
  }

  wapp_f32_array_extend_capped(output, other);

RETURN_F32_ARRAY_EXTEND_ALLOC:
  return output;
}

F32Array *wapp_f32_array_copy_alloc(const Allocator *allocator, const F32Array *src, F32Array *dst) {
  F32Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_F32_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (F32Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_F32_ARRAY_COPY_ALLOC;
    }
  }

  wapp_f32_array_clear(output);
  wapp_f32_array_copy_capped(src, output);

RETURN_F32_ARRAY_COPY_ALLOC:
  return output;
}

f32 *_f32_array_pop(F32Array *array) {
  u64 index = array->count - 1;
  f32 *out = wapp_f32_array_get(array, index);
  --(array->count);
  return out;
}

f64 *wapp_f64_array_get(const F64Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (f64 *)ptr;
}

void wapp_f64_array_set(F64Array *array, u64 index, f64 *item) {
  f64 *ptr = wapp_f64_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_f64_array_append_capped(F64Array *array, f64 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_f64_array_set(array, index, item);
}

void wapp_f64_array_extend_capped(F64Array *array, const F64Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  f64 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_f64_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_f64_array_append_capped(array, item);
  }
}

void wapp_f64_array_clear(F64Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_f64_array_copy_capped(const F64Array *src, F64Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_f64_array_clear(dst);

  f64 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_f64_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_f64_array_append_capped(dst, item);
  }
}

F64Array *wapp_f64_array_append_alloc(const Allocator *allocator, F64Array *array, f64 *item) {
  F64Array *output = array;

  if (!allocator || !array) {
    goto RETURN_F64_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (F64Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_F64_ARRAY_APPEND_ALLOC;
    }
    wapp_f64_array_copy_capped(array, output);
  }

  wapp_f64_array_append_capped(output, item);

RETURN_F64_ARRAY_APPEND_ALLOC:
  return output;
}

F64Array *wapp_f64_array_extend_alloc(const Allocator *allocator, F64Array *array, const F64Array *other) {
  F64Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_F64_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (F64Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_F64_ARRAY_EXTEND_ALLOC;
    }
    wapp_f64_array_copy_capped(array, output);
  }

  wapp_f64_array_extend_capped(output, other);

RETURN_F64_ARRAY_EXTEND_ALLOC:
  return output;
}

F64Array *wapp_f64_array_copy_alloc(const Allocator *allocator, const F64Array *src, F64Array *dst) {
  F64Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_F64_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (F64Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_F64_ARRAY_COPY_ALLOC;
    }
  }

  wapp_f64_array_clear(output);
  wapp_f64_array_copy_capped(src, output);

RETURN_F64_ARRAY_COPY_ALLOC:
  return output;
}

f64 *_f64_array_pop(F64Array *array) {
  u64 index = array->count - 1;
  f64 *out = wapp_f64_array_get(array, index);
  --(array->count);
  return out;
}

f128 *wapp_f128_array_get(const F128Array *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (f128 *)ptr;
}

void wapp_f128_array_set(F128Array *array, u64 index, f128 *item) {
  f128 *ptr = wapp_f128_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_f128_array_append_capped(F128Array *array, f128 *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_f128_array_set(array, index, item);
}

void wapp_f128_array_extend_capped(F128Array *array, const F128Array *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  f128 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_f128_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_f128_array_append_capped(array, item);
  }
}

void wapp_f128_array_clear(F128Array *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_f128_array_copy_capped(const F128Array *src, F128Array *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_f128_array_clear(dst);

  f128 *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_f128_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_f128_array_append_capped(dst, item);
  }
}

F128Array *wapp_f128_array_append_alloc(const Allocator *allocator, F128Array *array, f128 *item) {
  F128Array *output = array;

  if (!allocator || !array) {
    goto RETURN_F128_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (F128Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_F128_ARRAY_APPEND_ALLOC;
    }
    wapp_f128_array_copy_capped(array, output);
  }

  wapp_f128_array_append_capped(output, item);

RETURN_F128_ARRAY_APPEND_ALLOC:
  return output;
}

F128Array *wapp_f128_array_extend_alloc(const Allocator *allocator, F128Array *array, const F128Array *other) {
  F128Array *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_F128_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (F128Array *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_F128_ARRAY_EXTEND_ALLOC;
    }
    wapp_f128_array_copy_capped(array, output);
  }

  wapp_f128_array_extend_capped(output, other);

RETURN_F128_ARRAY_EXTEND_ALLOC:
  return output;
}

F128Array *wapp_f128_array_copy_alloc(const Allocator *allocator, const F128Array *src, F128Array *dst) {
  F128Array *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_F128_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (F128Array *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_F128_ARRAY_COPY_ALLOC;
    }
  }

  wapp_f128_array_clear(output);
  wapp_f128_array_copy_capped(src, output);

RETURN_F128_ARRAY_COPY_ALLOC:
  return output;
}

f128 *_f128_array_pop(F128Array *array) {
  u64 index = array->count - 1;
  f128 *out = wapp_f128_array_get(array, index);
  --(array->count);
  return out;
}

iptr *wapp_iptr_array_get(const IptrArray *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (iptr *)ptr;
}

void wapp_iptr_array_set(IptrArray *array, u64 index, iptr *item) {
  iptr *ptr = wapp_iptr_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_iptr_array_append_capped(IptrArray *array, iptr *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_iptr_array_set(array, index, item);
}

void wapp_iptr_array_extend_capped(IptrArray *array, const IptrArray *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  iptr *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_iptr_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_iptr_array_append_capped(array, item);
  }
}

void wapp_iptr_array_clear(IptrArray *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_iptr_array_copy_capped(const IptrArray *src, IptrArray *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_iptr_array_clear(dst);

  iptr *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_iptr_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_iptr_array_append_capped(dst, item);
  }
}

IptrArray *wapp_iptr_array_append_alloc(const Allocator *allocator, IptrArray *array, iptr *item) {
  IptrArray *output = array;

  if (!allocator || !array) {
    goto RETURN_IPTR_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (IptrArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_IPTR_ARRAY_APPEND_ALLOC;
    }
    wapp_iptr_array_copy_capped(array, output);
  }

  wapp_iptr_array_append_capped(output, item);

RETURN_IPTR_ARRAY_APPEND_ALLOC:
  return output;
}

IptrArray *wapp_iptr_array_extend_alloc(const Allocator *allocator, IptrArray *array, const IptrArray *other) {
  IptrArray *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_IPTR_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (IptrArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_IPTR_ARRAY_EXTEND_ALLOC;
    }
    wapp_iptr_array_copy_capped(array, output);
  }

  wapp_iptr_array_extend_capped(output, other);

RETURN_IPTR_ARRAY_EXTEND_ALLOC:
  return output;
}

IptrArray *wapp_iptr_array_copy_alloc(const Allocator *allocator, const IptrArray *src, IptrArray *dst) {
  IptrArray *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_IPTR_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (IptrArray *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_IPTR_ARRAY_COPY_ALLOC;
    }
  }

  wapp_iptr_array_clear(output);
  wapp_iptr_array_copy_capped(src, output);

RETURN_IPTR_ARRAY_COPY_ALLOC:
  return output;
}

iptr *_iptr_array_pop(IptrArray *array) {
  u64 index = array->count - 1;
  iptr *out = wapp_iptr_array_get(array, index);
  --(array->count);
  return out;
}

uptr *wapp_uptr_array_get(const UptrArray *array, u64 index) {
  if (!array || index >= array->count) {
    return NULL;
  }

  u8 *ptr = (u8 *)(array->items) + (array->item_size * index);
  return (uptr *)ptr;
}

void wapp_uptr_array_set(UptrArray *array, u64 index, uptr *item) {
  uptr *ptr = wapp_uptr_array_get(array, index);
  if (!ptr) {
    return;
  }

  memcpy((void *)ptr, (void *)item, array->item_size);
}

void wapp_uptr_array_append_capped(UptrArray *array, uptr *item) {
  if (!array || array->count >= array->capacity) {
    return;
  }

  u64 index = (array->count)++;
  wapp_uptr_array_set(array, index, item);
}

void wapp_uptr_array_extend_capped(UptrArray *array, const UptrArray *other) {
  if (!array || !other) {
    return;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    return;
  }

  uptr *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 items_to_add = other->count;
  u64 item_index   = 0;
  bool running     = true;
  while (running) {
    item = wapp_uptr_array_get(other, item_index);
    ++item_index;
    running = item_index < items_to_add;

    if (!item) {
      continue;
    }

    wapp_uptr_array_append_capped(array, item);
  }
}

void wapp_uptr_array_clear(UptrArray *array) {
  if (!array) {
    return;
  }

  array->count = 0;
}

void wapp_uptr_array_copy_capped(const UptrArray *src, UptrArray *dst) {
  if (!src || !dst) {
    return;
  }

  wapp_uptr_array_clear(dst);

  uptr *item;

  // NOTE (Abdelrahman): Uses a while loop instead of a for loop to get rid of
  // MSVC Spectre mitigation warnings
  u64 to_copy    = src->count < dst->capacity ? src->count : dst->capacity;
  u64 item_index = 0;
  bool running   = true;
  while (running) {
    item = wapp_uptr_array_get(src, item_index);
    ++item_index;
    running = item_index < to_copy;

    if (!item) {
      continue;
    }
    
    wapp_uptr_array_append_capped(dst, item);
  }
}

UptrArray *wapp_uptr_array_append_alloc(const Allocator *allocator, UptrArray *array, uptr *item) {
  UptrArray *output = array;

  if (!allocator || !array) {
    goto RETURN_UPTR_ARRAY_APPEND_ALLOC;
  }

  if (array->count >= array->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (UptrArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_UPTR_ARRAY_APPEND_ALLOC;
    }
    wapp_uptr_array_copy_capped(array, output);
  }

  wapp_uptr_array_append_capped(output, item);

RETURN_UPTR_ARRAY_APPEND_ALLOC:
  return output;
}

UptrArray *wapp_uptr_array_extend_alloc(const Allocator *allocator, UptrArray *array, const UptrArray *other) {
  UptrArray *output = array;

  if (!allocator || !array || !other) {
    goto RETURN_UPTR_ARRAY_EXTEND_ALLOC;
  }

  u64 remaining_capacity = array->capacity - array->count;
  if (other->count >= remaining_capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(array->capacity * 2);
    output           = (UptrArray *)_array_alloc_capacity(allocator, new_capacity, array->item_size);
    if (!output) {
      output = array;
      goto RETURN_UPTR_ARRAY_EXTEND_ALLOC;
    }
    wapp_uptr_array_copy_capped(array, output);
  }

  wapp_uptr_array_extend_capped(output, other);

RETURN_UPTR_ARRAY_EXTEND_ALLOC:
  return output;
}

UptrArray *wapp_uptr_array_copy_alloc(const Allocator *allocator, const UptrArray *src, UptrArray *dst) {
  UptrArray *output = dst;

  if (!allocator || !src || !dst) {
    goto RETURN_UPTR_ARRAY_COPY_ALLOC;
  }

  if (src->count >= dst->capacity) {
    u64 new_capacity = wapp_misc_utils_u64_round_up_pow2(dst->capacity * 2);
    output           = (UptrArray *)_array_alloc_capacity(allocator, new_capacity, src->item_size);
    if (!output) {
      output = dst;
      goto RETURN_UPTR_ARRAY_COPY_ALLOC;
    }
  }

  wapp_uptr_array_clear(output);
  wapp_uptr_array_copy_capped(src, output);

RETURN_UPTR_ARRAY_COPY_ALLOC:
  return output;
}

uptr *_uptr_array_pop(UptrArray *array) {
  u64 index = array->count - 1;
  uptr *out = wapp_uptr_array_get(array, index);
  --(array->count);
  return out;
}

VoidPArray *_array_alloc_capacity(const Allocator *allocator, u64 capacity, u64 item_size) {
  u64 allocation_size = sizeof(VoidPArray) + item_size * capacity;
  VoidPArray *array   = NULL;

  if (!allocator) {
    goto RETURN_GENERIC_ARRAY_ALLOC;
  }

  array = wapp_mem_allocator_alloc(allocator, allocation_size);
  if (!array) {
    goto RETURN_GENERIC_ARRAY_ALLOC;
  }

  array->items     = (void * *)((u8 *)array + sizeof(VoidPArray));
  array->count     = 0;
  array->capacity  = capacity;
  array->item_size = item_size;

RETURN_GENERIC_ARRAY_ALLOC:
  return array;
}

